#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <cstring>
#include <set>
#include <algorithm>
#include <string>
#include <queue>
#include <cassert>
 
using namespace std;

int n, m;
int g[60][60], prz[60][60];
int deg[60];


bool topoSort()
{
	vector<int> kol;
	kol.clear();
	for(int i=0; i<n; ++i) deg[i] = 0;
	for(int i=0; i<n; ++i)
		for(int j=0; j<n; ++j)
			if(g[i][j] == 1) deg[j]++;
	
	queue<int> q;
	for(int i=0; i<n; ++i)
	{
		if(deg[i] == 0)
		{
			q.push(i);
		}
	}
	while(!q.empty())
	{
		int w = q.front();
		q.pop();
		kol.push_back(w);
		for(int i=0; i<n; ++i)
		{
			if(g[w][i] == 1)
			{
				deg[i]--;
				if(deg[i] == 0)
				{
					q.push(i);
				}
			}
		}
	}
	return (int)kol.size() == n;
}

bool czyMozna()
{
	for(int i=0; i<n; ++i) for(int j=0; j<n; ++j) prz[i][j] = g[i][j];
	for(int k=0; k<n; ++k)
		for(int i=0; i<n; ++i)
			for(int j=0; j<n; ++j)
				if(prz[i][k] == 1 && prz[k][j] == 1)
				{
					prz[i][j] = 1;
				}
	for(int i=0; i<n; ++i)
		for(int j=0; j<n; ++j)
			if(g[i][j] != prz[i][j])
			{
				return false;
			}
	return topoSort();
}

typedef long long ll;

const int base = 1000000000, digs = 9;
class BN : public vector<ll>
{
public:
	BN(){ push_back(0); }
	
	BN(int s, ll v) : vector<ll>(s, v) {}
	
	BN(const string& s);
	
	void write() const;
};

void BN::write() const
{
	printf("%lld", back());
	for(int i=size()-2; i>=0; --i) printf("%0*lld", digs, (*this)[i]);
	printf("\n");
}

BN::BN(const string& s)
{
	clear();
	ll cur = 0, done = 0, act = 1;
	for(int i=(int)s.size()-1; i>=0; --i)
	{
		cur += (s[i]-'0') * act;
		done++;
		act *= 10;
		if(done == digs)
		{
			push_back(cur);
			cur = done = 0;
			act = 1;
		}
	}
	if(cur != 0 || size() == 0) push_back(cur);
}

BN bg[60];

bool operator < (const BN& fst, const BN& snd)
{
	if(fst.size() != snd.size()) return fst.size() < snd.size();
	for(int i=(int)fst.size()-1; i>=0; --i)
		if(fst[i] != snd[i]) return fst[i] < snd[i];
	return false;
}

BN operator - (const BN& fst, const BN& snd)
{
	assert(!(fst < snd));
	BN res(fst.size(), 0);
	ll next = 0;
	for(int i=0; i<fst.size(); ++i)
	{
		res[i] = next + fst[i] - (i < snd.size() ? snd[i] : 0);
		if(res[i] < 0){ next = -1; res[i] += base; }
		else next = 0;
	}
	while((int)res.size() > 1 && res.back() == 0) res.pop_back();
	return res;
}


bool parzysta(const BN& bn)
{
	return bn[0] % 2 == 0;
}

void naDwa(BN& bn)
{
	assert(parzysta(bn));
	for(int i=(int)bn.size()-1; i>=0; --i)
	{
		if(bn[i] % 2 == 1) bn[i-1] += base;
		bn[i] /= 2;
	}
	if(bn.back() == 0) bn.pop_back();
}

bool czyDzieli(const int nr1, const int nr2)
{
	BN d = bg[nr1];
	BN D = bg[nr2];
	
	if(D < d) return false;
	
	while(parzysta(d))
	{
		if(!parzysta(D)) return false;
		naDwa(d);
		naDwa(D);
	}
	while(d < D)
	{
		if(parzysta(D)) naDwa(D);
		else D = D - d;
	}
	
	return !(D < d);
}

int main(int argc, char *argv[])
{
	#define RET { return 1; }
 
	ios_base::sync_with_stdio(0);
	//string infile = getenv("SPRW_WORKING_DIR"); infile+="/taskdata/"; infile+=getenv("SPR_infile");
	ifstream in(argv[1]);
	
	// input
	int cases;
	in >> cases;
	while(cases--){
		in >> n >> m;
		memset(g, 0, sizeof(g));
		while(m--){
			int a, b;
			in >> a >> b;
			a--; b--;
			g[a][b] = 1;
		}
		
		bool mozna = czyMozna();
		
		// output
		string ans;
		cin >> ans; if(cin.fail() || cin.bad()) RET;
		if(!mozna)
		{
			if(ans != "NIE") RET;
			continue;
		}
		
		if(ans != "TAK") RET;
		
		for(int i=0; i<n; ++i)
		{
			string s;
			cin >> s; if(cin.fail() || cin.bad()) RET;
			if((int)s.size() > 1000 || s.empty() || s[0] == '0') RET;
			for(int j=0; j<s.size(); ++j)
			{
				if(s[j] < '0' || s[j] > '9') RET;
			}
			bg[i] = BN(s);
		}
		for(int i=0; i<n; ++i)
			for(int j=0; j<n; ++j)
				if(i != j && (g[i][j] == 1) != czyDzieli(i,j)) RET;
	}
	
	if(cin.bad() || cin.fail()) RET;
	
	return 0;
}
